local addon_name, ns = ...

local rearrange = {}
local GetCursorPosition = GetCursorPosition
--------------------------------------------------------------------------------

local function GetIndex(t, b)
    for k, v in ipairs(t) do
        if v == b then return k end
    end
end

local function MouseInFrame(frame, x, y, coord, s)
    local es = frame:GetEffectiveScale()
    x, y = x / es, y / es
    local h = frame:GetHeight()
    local w = frame:GetWidth()
    local ytest = y <= frame:GetTop() - h / s and y >= frame:GetBottom() + h / s
    local xtest = x <= frame:GetRight() and x >= frame:GetLeft()
    return (coord == "x" and xtest) or (coord == "y" and ytest) or (xtest and ytest)
end

function rearrange.BeginMoving(queue, frame, btn)
    if not frame.isMoving then
        frame:SetAlpha(0.8)
        frame.isMoving = true
        local _, y = GetCursorPosition()
        queue.initPos = GetIndex(queue.frames, frame)
        queue.movingFrame = frame
        queue.unstick = true
    end
end

function rearrange.EndMoving(queue, frame, btn)
    if frame.isMoving then
        frame:SetAlpha(1)
        frame.isMoving = false
        --queue:MoveFrame(frame, queue.initPos)
        queue.initPos = nil
        queue.unstick = nil
        queue:AnchorFrames()
    end
end

local function GetNewIndex(queue, func, ...)
    for i, other in ipairs(queue.frames) do
        if i ~= queue.initPos and func(other, ...) then
            return i
        end
    end
    return queue.initPos
end

function rearrange.MouseUpdate(queue, frame, elapsed)
    if frame.isMoving then
        local x, y = GetCursorPosition()
        local s = frame:GetEffectiveScale()
        local ip = GetNewIndex(queue, MouseInFrame, x, y, "y", 3)
        queue:MoveFrame(frame, ip)
        queue.initPos = ip

        queue:AnchorFrames()
        frame:ClearAllPoints()
        frame:SetPoint("CENTER", nil, "BOTTOMLEFT", x / s, y / s)
    end
end
--------------------------------------------------------------------------------
ns.rearrange = rearrange
